package com.oreilly.jent.transactions.bmtd;

/**
 * In general, you may use the code in this book in your programs and 
 * documentation. You do not need to contact us for permission unless 
 * you're reproducing a significant portion of the code. For example, 
 * writing a program that uses several chunks of code from this book does 
 * not require permission. Selling or distributing a CD-ROM of examples 
 * from O'Reilly books does require permission. Answering a question by 
 * citing this book and quoting example code does not require permission. 
 * Incorporating a significant amount of example code from this book into 
 * your product's documentation does require permission.
 * 
 * We appreciate, but do not require, attribution. An attribution usually 
 * includes the title, author, publisher, and ISBN. For example: 
 * 
 *   "Java Enterprise in a Nutshell, Third Edition, 
 *    by Jim Farley and William Crawford 
 *    with Prakash Malani, John G. Norman, and Justin Gehtland. 
 *    Copyright 2006 O'Reilly Media, Inc., 0-596-10142-2."
 *  
 *  If you feel your use of code examples falls outside fair use or the 
 *  permission given above, feel free to contact us at 
 *  permissions@oreilly.com.
 */

import java.rmi.RemoteException;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.naming.InitialContext;
import javax.transaction.UserTransaction;

import com.oreilly.jent.transactions.domain.Person;
import com.oreilly.jent.transactions.domain.PersonHome;
import com.oreilly.jent.transactions.domain.PersonValue;

public class ManagerBMTDBean implements SessionBean {
    protected static Logger sLogger = Logger.getLogger(ManagerBMTDBean.class.getName());
    protected SessionContext mSessionContext;

    public PersonValue createPerson(PersonValue aPersonValue) {
        sLogger.info(" in manager bmtd bean. create person ");

        UserTransaction aUserTransaction = mSessionContext.getUserTransaction();
        try {
            aUserTransaction.begin();
            InitialContext aInitialContext = new InitialContext();
            PersonHome aPersonHome = (PersonHome) aInitialContext.lookup("java:comp/env/ejb/Person");
            Person p = aPersonHome.create(aPersonValue.getEmail(), aPersonValue.getPassword());
            p.setWorkPhone(aPersonValue.getWorkPhone());
            p.setHomePhone(aPersonValue.getHomePhone());

            sLogger.info("Created a person with id : " + p.getPersonId());
            aPersonValue.setPersonId(p.getPersonId());
            aUserTransaction.commit();
        } catch (Exception e) {
            try {
                aUserTransaction.rollback();
            } catch (Exception aException) {
                String aMessage = "Exception occured in manager bmtd bean.create Person";
                sLogger.log(Level.SEVERE, aMessage, aException);
                throw new EJBException(aException);
            }
            String aMessage = "Exception occured in manager bmtd bean.create Person";
            sLogger.log(Level.SEVERE, aMessage, e);
            throw new EJBException(e);
        }

        return aPersonValue;
    }

    public void ejbCreate() {

    }

    public void setSessionContext(SessionContext aSessionContext) throws EJBException, RemoteException {
        mSessionContext = aSessionContext;
    }

    public void ejbRemove() throws EJBException, RemoteException {
    }

    public void ejbActivate() throws EJBException, RemoteException {
    }

    public void ejbPassivate() throws EJBException, RemoteException {
    }
}

